"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "useKeycloak", {
  enumerable: true,
  get: function get() {
    return _web.useKeycloak;
  }
});
exports.useToken = exports.useTock = exports.timeLeft = exports.AccountRoute = exports.RegisterRoute = exports.LogoutRoute = exports.LoginRoute = exports.Protect = exports.PrivateRoute = exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactRouterDom = require("react-router-dom");

var _web = require("@react-keycloak/web");

var _excluded = ["url", "clientId", "realm", "loginPath", "logoutPath", "onTokens", "initOptions", "keycloakOptions", "offline", "appendPath", "children"],
    _excluded2 = ["render"],
    _excluded3 = ["path", "redirectTo"],
    _excluded4 = ["path", "redirectTo"],
    _excluded5 = ["path", "options"],
    _excluded6 = ["path", "options"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var pyStrRStrip = function pyStrRStrip(src, chars) {
  var escaped = chars.replace(/([.*+?^=!:${}()|\[\]\/\\])/g, "\\$1");
  return src.replace(RegExp("[" + escaped + "]+$", "gm"), '');
};

var KeycloakProvider = function KeycloakProvider(_ref) {
  var url = _ref.url,
      clientId = _ref.clientId,
      _ref$realm = _ref.realm,
      realm = _ref$realm === void 0 ? 'master' : _ref$realm,
      _ref$loginPath = _ref.loginPath,
      loginPath = _ref$loginPath === void 0 ? '/login' : _ref$loginPath,
      _ref$logoutPath = _ref.logoutPath,
      logoutPath = _ref$logoutPath === void 0 ? '/logout' : _ref$logoutPath,
      _onTokens = _ref.onTokens,
      initOptions = _ref.initOptions,
      keycloakOptions = _ref.keycloakOptions,
      _ref$offline = _ref.offline,
      offline = _ref$offline === void 0 ? false : _ref$offline,
      _ref$appendPath = _ref.appendPath,
      appendPath = _ref$appendPath === void 0 ? true : _ref$appendPath,
      children = _ref.children,
      props = _objectWithoutProperties(_ref, _excluded);

  var _React$useState = _react["default"].useState(null),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      keycloak = _React$useState2[0],
      setKeycloak = _React$useState2[1]; // append /auth because we need it, but it's annoying to add


  if (appendPath) {
    url = url.replace(/\/$/, '') + (appendPath === true ? '/auth' : appendPath);
  }

  url = pyStrRStrip(url, '/'); // build constructor arguments

  keycloakOptions = keycloakOptions || {};

  if (offline) {
    keycloakOptions.scope = (keycloakOptions.scope ? keycloakOptions.scope + ' ' : keycloakOptions.scope) + 'offline_access';
  } // initialize keycloak object


  _react["default"].useEffect(function () {
    if (!clientId) {
      throw new Error('There is no client id configured');
    }

    var create = function create() {
      var tokens = tokensStash.get();
      var kc = wrapKeycloak(new window.Keycloak(_objectSpread(_objectSpread({
        url: url,
        realm: realm,
        clientId: clientId
      }, tokens), keycloakOptions)));
      kc.loginPath = loginPath;
      kc.logoutPath = logoutPath;
      setKeycloak(kc);
    };

    if (!window.Keycloak) {
      insertScript(url + '/js/keycloak.js').then(function () {
        // console.log('loaded keycloak', window.Keycloak)
        create();
      });
      return;
    }

    create();
  }, [url, realm, clientId]);

  return keycloak && /*#__PURE__*/_react["default"].createElement(_web.ReactKeycloakProvider, _extends({
    authClient: keycloak,
    onTokens: function onTokens(tokens) {
      tokensStash.set(tokens);
      _onTokens && _onTokens(tokens);
    },
    initOptions: _objectSpread({}, initOptions)
  }, props), children);
};

var _default = KeycloakProvider;
exports["default"] = _default;

var PrivateRoute = function PrivateRoute(_ref2) {
  var _render = _ref2.render,
      routeProps = _objectWithoutProperties(_ref2, _excluded2);

  var _useKeycloak = (0, _web.useKeycloak)(),
      keycloak = _useKeycloak.keycloak;

  return /*#__PURE__*/_react["default"].createElement(_reactRouterDom.Route, _extends({}, routeProps, {
    render: function render(props) {
      return timeLeft(keycloak.tokenParsed) > 0 && _render(props) || /*#__PURE__*/_react["default"].createElement(_reactRouterDom.Redirect, {
        to: {
          pathname: '/login',
          state: {
            from: props.location
          }
        }
      });
    }
  }));
};

exports.PrivateRoute = PrivateRoute;

var Login = function Login(_ref3) {
  var children = _ref3.children,
      redirectTo = _ref3.redirectTo,
      loginOptions = _ref3.loginOptions,
      location = _ref3.location,
      onSuccess = _ref3.onSuccess;

  var _useKeycloak2 = (0, _web.useKeycloak)(),
      keycloak = _useKeycloak2.keycloak;

  _react["default"].useEffect(function () {
    if (keycloak.authenticated) {
      onSuccess && onSuccess(keycloak.token);
      return;
    } // Store the current path in session storage before leaving the application to log in on keycloak server


    location.state && location.state.redirectTo && redirectStash.set(location.state.redirectTo);
    keycloak.login(loginOptions || {}); // Redirect to keycloak login page
  }, [keycloak, location.state, onSuccess]);

  return timeLeft(keycloak.tokenParsed) > 0 && (children || /*#__PURE__*/_react["default"].createElement("div", null, "Connecting...")) || /*#__PURE__*/_react["default"].createElement(_reactRouterDom.Redirect, {
    to: redirectStash.pop(redirectTo || '/')
  });
};

var Logout = function Logout(_ref4) {
  var children = _ref4.children,
      redirectTo = _ref4.redirectTo,
      onSuccess = _ref4.onSuccess;

  var _useKeycloak3 = (0, _web.useKeycloak)(),
      keycloak = _useKeycloak3.keycloak;

  _react["default"].useEffect(function () {
    keycloak.authenticated && keycloak.logout() || onSuccess && onSuccess();
  }, [keycloak, onSuccess]);

  return keycloak.authenticated && (children || /*#__PURE__*/_react["default"].createElement("div", null, "Disconnecting...")) || /*#__PURE__*/_react["default"].createElement(_reactRouterDom.Redirect, {
    to: redirectStash.pop(redirectTo || '/')
  });
};

var Protect = function Protect(_ref5) {
  var children = _ref5.children,
      unprotected = _ref5.unprotected;

  var _useKeycloak4 = (0, _web.useKeycloak)(),
      keycloak = _useKeycloak4.keycloak;

  return keycloak.authenticated && children() || unprotected && unprotected();
};

exports.Protect = Protect;

var LoginRoute = function LoginRoute(_ref6) {
  var path = _ref6.path,
      _ref6$redirectTo = _ref6.redirectTo,
      redirectTo = _ref6$redirectTo === void 0 ? '/' : _ref6$redirectTo,
      props = _objectWithoutProperties(_ref6, _excluded3);

  var _useKeycloak5 = (0, _web.useKeycloak)(),
      keycloak = _useKeycloak5.keycloak;

  return /*#__PURE__*/_react["default"].createElement(_reactRouterDom.Route, _extends({
    path: path || keycloak.loginPath || '/login'
  }, props, {
    render: function render(p) {
      return /*#__PURE__*/_react["default"].createElement(Login, _extends({
        redirectTo: redirectTo
      }, p));
    }
  }));
};

exports.LoginRoute = LoginRoute;

var LogoutRoute = function LogoutRoute(_ref7) {
  var path = _ref7.path,
      _ref7$redirectTo = _ref7.redirectTo,
      redirectTo = _ref7$redirectTo === void 0 ? '/' : _ref7$redirectTo,
      props = _objectWithoutProperties(_ref7, _excluded4);

  var _useKeycloak6 = (0, _web.useKeycloak)(),
      keycloak = _useKeycloak6.keycloak;

  return /*#__PURE__*/_react["default"].createElement(_reactRouterDom.Route, _extends({
    path: path || keycloak.logoutPath || '/logout'
  }, props, {
    render: function render(p) {
      return /*#__PURE__*/_react["default"].createElement(Logout, _extends({
        redirectTo: redirectTo
      }, p));
    }
  }));
};

exports.LogoutRoute = LogoutRoute;

var RegisterRoute = function RegisterRoute(_ref8) {
  var path = _ref8.path,
      options = _ref8.options,
      props = _objectWithoutProperties(_ref8, _excluded5);

  var _useKeycloak7 = (0, _web.useKeycloak)(),
      keycloak = _useKeycloak7.keycloak;

  return /*#__PURE__*/_react["default"].createElement(_reactRouterDom.Route, _extends({
    path: path || keycloak.registerPath || '/register'
  }, props, {
    render: function render(p) {
      return /*#__PURE__*/_react["default"].createElement(_reactRouterDom.Redirect, _extends({
        to: keycloak.createRegisterUrl(options)
      }, p));
    }
  }));
};

exports.RegisterRoute = RegisterRoute;

var AccountRoute = function AccountRoute(_ref9) {
  var path = _ref9.path,
      options = _ref9.options,
      props = _objectWithoutProperties(_ref9, _excluded6);

  var _useKeycloak8 = (0, _web.useKeycloak)(),
      keycloak = _useKeycloak8.keycloak;

  return /*#__PURE__*/_react["default"].createElement(_reactRouterDom.Route, _extends({
    path: path || keycloak.accountPath || '/account'
  }, props, {
    render: function render(p) {
      return /*#__PURE__*/_react["default"].createElement(_reactRouterDom.Redirect, _extends({
        to: keycloak.createAccountUrl(options)
      }, p));
    }
  }));
}; // const getToken = (keycloak, name) => {
//     name = name ? name+'Token' : 'token';
//     return { token: keycloak[name], data: keycloak[name+'Parsed'] };
// }


exports.AccountRoute = AccountRoute;

var timeLeft = function timeLeft(token) {
  return token && token.exp ? token.exp - Math.ceil(new Date().getTime() / 1000) : 0;
};

exports.timeLeft = timeLeft;

var useTock = function useTock() {
  var period = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 1;

  var _React$useState3 = _react["default"].useState(new Date().getTime() / 1000),
      _React$useState4 = _slicedToArray(_React$useState3, 2),
      time = _React$useState4[0],
      setTime = _React$useState4[1];

  _react["default"].useEffect(function () {
    var id = period && setInterval(function () {
      return setTime(new Date().getTime() / 1000);
    }, period * 1000);
    return function () {
      return id && clearInterval(id);
    };
  }, [period]);

  return time;
};
/* polls for token changes */


exports.useTock = useTock;

var useToken = function useToken(period) {
  var name = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
  var key = name ? name + 'Token' : 'token';
  period = period == null ? name === 'refresh' ? 10 : 1 : period;

  var _React$useState5 = _react["default"].useState({}),
      _React$useState6 = _slicedToArray(_React$useState5, 2),
      tokens = _React$useState6[0],
      setTokens = _React$useState6[1];

  var _useKeycloak9 = (0, _web.useKeycloak)(),
      K = _useKeycloak9.keycloak;

  _react["default"].useEffect(function () {
    if (period != false) {
      var check = function check() {
        if (tokens.token !== K[key]) {
          setTokens({
            token: K[key],
            data: K[key + 'Parsed']
          });
        }
      };

      check();
      var id = period && setInterval(check, period * 1000);
      return function () {
        return id && clearInterval(id);
      };
    }
  }, [period, key, K, tokens]);

  return tokens;
};
/* This lets you add multiple events to keycloak */


exports.useToken = useToken;

var wrapKeycloak = function wrapKeycloak(kc) {
  var events = {};

  kc.on = function (k, callback) {
    var key = 'on' + k.charAt(0).toUpperCase() + k.slice(1);
    events[key].push(callback);
    return function () {
      events[key] = events[key].filter(function (c) {
        return c != callback;
      });
    };
  };

  var _loop = function _loop() {
    var k = _arr2[_i2];
    events[k] = events[k] || [];
    if (kc[k]) kc.on(k, kc[k]);

    kc[k] = function () {
      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      return events[k].map(function (cb) {
        return cb.apply(void 0, args);
      });
    };
  };

  for (var _i2 = 0, _arr2 = ['onReady', 'onAuthSuccess', 'onAuthError', 'onAuthRefreshSuccess', 'onAuthRefreshError', 'onAuthLogout', 'onTokenExpired']; _i2 < _arr2.length; _i2++) {
    _loop();
  }

  return kc;
};

var Stash = /*#__PURE__*/function () {
  /* This lets us store a variable and retrieve it after getting redirected back. */
  function Stash(key) {
    _classCallCheck(this, Stash);

    this.key = key;
  }

  _createClass(Stash, [{
    key: "get",
    value: function get() {
      var alt = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;

      var x = this._get();

      return x != null ? x : alt;
    }
  }, {
    key: "_get",
    value: function _get() {
      var x = JSON.parse(window.sessionStorage.getItem(this.key) || 'null');
      return x;
    } //  console.log('getting', x);

  }, {
    key: "set",
    value: function set(value) {
      window.sessionStorage.setItem(this.key, JSON.stringify(value));
    } // console.log('setting', value);

  }, {
    key: "delete",
    value: function _delete() {
      window.sessionStorage.removeItem(this.key);
    } // console.log('deleting', this.key);

  }, {
    key: "pop",
    value: function pop() {
      var alt = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
      var x = this.get(alt);
      this["delete"]();
      return x;
    }
  }]);

  return Stash;
}();

var redirectStash = new Stash('keycloak-react-router:redirectTo');
var tokensStash = new Stash('keycloak-react-router:tokens');

var insertScript = function insertScript(path) {
  return new Promise(function (resolve, reject) {
    var s = document.createElement('script');
    s.src = path;

    s.onload = function () {
      return resolve(s);
    }; // resolve with script, not event


    s.onerror = reject;
    document.body.appendChild(s);
  });
};